import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvFileSource;
import org.junit.jupiter.params.provider.CsvSource;
import org.junit.jupiter.params.provider.ValueSource;
import org.junit.Test;
import org.junit.Before;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class CollapseSpacesTest {

    public CollapseSpaces cs;

    @Before
    public void setUp() {
	cs = new CollapseSpaces();
    }
    
    @Test
    public void T1() {
    	String res = cs.collapseSpaces("ciao  ciao");
        assertTrue(res.equals("ciao ciao"));
    }
    
    @Test
    public void T2() {
    	String res = cs.collapseSpaces("ciao ciao");
        assertTrue(res.equals("ciao ciao"));
    }

    //ignored, see https://www.baeldung.com/parameterized-tests-junit-5
    @ParameterizedTest
    @CsvFileSource(resources = "input.csv")
    public void Many(String in, String out) {
    	String res = cs.collapseSpaces(in);
        assertTrue(res.equals(out));
    }
}
